local rName = GetRealmName();
local pName = UnitName("player");
local ooprocessed = 0;
frspversion = GetAddOnMetadata("flagRSP2", "Version");
rspsendbuffer = {};

flagRSP2.defaults = {
    profile = {
		flagRSP2OptionsSaveDescCheck = true,
		flagRSP2OptionsShowDescCheck = true,
		flagRSP2OptionsTargetDescCheck = false,
		flagRSP2OptionsStickyDescCheck = false,
		flagRSP2OptionsHideCombatCheck = true,
		flagRSP2OptionsWordLimitCheck = false,
		flagRSP2OptionsAFKCheck = true,

		flagRSP2TooltipLightModeCheck = false,
		flagRSP2TooltipFRSP2TTCheck = true,
		flagRSP2TooltipShowAddNameCheck = true,
		flagRSP2TooltipShowTitleCheck = true,
		flagRSP2TooltipShowGuildCheck = true,
		flagRSP2TooltipShowStatusCheck = true,
		flagRSP2TooltipShowPvPCheck = false,
		flagRSP2TooltipShowPvPTitleCheck = false,
		flagRSP2DescShowTitleCheck = true,
		flagRSP2DescShowStatusCheck = true,
		
		flagRSP2DescAutoDBCleanCheck = false,
		flagRSP2MMIconCheck = true,
    },
}

--General Options
function flagRSP2:GetflagRSP2OptionsSaveDescCheck()
	return flagRSP2.db.profile.flagRSP2OptionsSaveDescCheck
end
function flagRSP2:SetflagRSP2OptionsSaveDescCheck()
	flagRSP2.db.profile.flagRSP2OptionsSaveDescCheck = not flagRSP2.db.profile.flagRSP2OptionsSaveDescCheck
end
function flagRSP2:GetflagRSP2OptionsShowDescCheck()
	return flagRSP2.db.profile.flagRSP2OptionsShowDescCheck
end
function flagRSP2:SetflagRSP2OptionsShowDescCheck()
	flagRSP2.db.profile.flagRSP2OptionsShowDescCheck = not flagRSP2.db.profile.flagRSP2OptionsShowDescCheck
end
function flagRSP2:GetflagRSP2OptionsTargetDescCheck()
	return flagRSP2.db.profile.flagRSP2OptionsTargetDescCheck
end
function flagRSP2:SetflagRSP2OptionsTargetDescCheck()
	flagRSP2.db.profile.flagRSP2OptionsTargetDescCheck = not flagRSP2.db.profile.flagRSP2OptionsTargetDescCheck
end
function flagRSP2:GetflagRSP2OptionsStickyDescCheck()
	return flagRSP2.db.profile.flagRSP2OptionsStickyDescCheck
end
function flagRSP2:SetflagRSP2OptionsStickyDescCheck()
	flagRSP2.db.profile.flagRSP2OptionsStickyDescCheck = not flagRSP2.db.profile.flagRSP2OptionsStickyDescCheck
end
function flagRSP2:GetflagRSP2OptionsHideCombatCheck()
	return flagRSP2.db.profile.flagRSP2OptionsHideCombatCheck
end
function flagRSP2:SetflagRSP2OptionsHideCombatCheck()
	flagRSP2.db.profile.flagRSP2OptionsHideCombatCheck = not flagRSP2.db.profile.flagRSP2OptionsHideCombatCheck
end
function flagRSP2:GetflagRSP2OptionsWordLimitCheck()
	return flagRSP2.db.profile.flagRSP2OptionsWordLimitCheck
end
function flagRSP2:SetflagRSP2OptionsWordLimitCheck()
	flagRSP2.db.profile.flagRSP2OptionsWordLimitCheck = not flagRSP2.db.profile.flagRSP2OptionsWordLimitCheck
end
function flagRSP2:GetflagRSP2OptionsAFKCheck()
	return flagRSP2.db.profile.flagRSP2OptionsAFKCheck
end
function flagRSP2:SetflagRSP2OptionsAFKCheck()
	flagRSP2.db.profile.flagRSP2OptionsAFKCheck = not flagRSP2.db.profile.flagRSP2OptionsAFKCheck
end

--Tooltip/Description Pop Up Options
function flagRSP2:GetflagRSP2TooltipLightModeCheck()
	return flagRSP2.db.profile.flagRSP2TooltipLightModeCheck
end
function flagRSP2:SetflagRSP2TooltipLightModeCheck()
	flagRSP2.db.profile.flagRSP2TooltipLightModeCheck = not flagRSP2.db.profile.flagRSP2TooltipLightModeCheck
end
function flagRSP2:GetflagRSP2TooltipFRSP2TTCheck()
	return flagRSP2.db.profile.flagRSP2TooltipFRSP2TTCheck
end
function flagRSP2:SetflagRSP2TooltipFRSP2TTCheck()
	flagRSP2.db.profile.flagRSP2TooltipFRSP2TTCheck = not flagRSP2.db.profile.flagRSP2TooltipFRSP2TTCheck
end
function flagRSP2:GetflagRSP2TooltipShowAddNameCheck()
	return flagRSP2.db.profile.flagRSP2TooltipShowAddNameCheck
end
function flagRSP2:SetflagRSP2TooltipShowAddNameCheck()
	flagRSP2.db.profile.flagRSP2TooltipShowAddNameCheck = not flagRSP2.db.profile.flagRSP2TooltipShowAddNameCheck
end
function flagRSP2:GetflagRSP2TooltipShowTitleCheck()
	return flagRSP2.db.profile.flagRSP2TooltipShowTitleCheck
end
function flagRSP2:SetflagRSP2TooltipShowTitleCheck()
	flagRSP2.db.profile.flagRSP2TooltipShowTitleCheck = not flagRSP2.db.profile.flagRSP2TooltipShowTitleCheck
end
function flagRSP2:GetflagRSP2TooltipShowGuildCheck()
	return flagRSP2.db.profile.flagRSP2TooltipShowGuildCheck
end
function flagRSP2:SetflagRSP2TooltipShowGuildCheck()
	flagRSP2.db.profile.flagRSP2TooltipShowGuildCheck = not flagRSP2.db.profile.flagRSP2TooltipShowGuildCheck
end
function flagRSP2:GetflagRSP2TooltipShowStatusCheck()
	return flagRSP2.db.profile.flagRSP2TooltipShowStatusCheck
end
function flagRSP2:SetflagRSP2TooltipShowStatusCheck()
	flagRSP2.db.profile.flagRSP2TooltipShowStatusCheck = not flagRSP2.db.profile.flagRSP2TooltipShowStatusCheck
end
function flagRSP2:GetflagRSP2TooltipShowPvPCheck()
	return flagRSP2.db.profile.flagRSP2TooltipShowPvPCheck
end
function flagRSP2:SetflagRSP2TooltipShowPvPCheck()
	flagRSP2.db.profile.flagRSP2TooltipShowPvPCheck = not flagRSP2.db.profile.flagRSP2TooltipShowPvPCheck
end
function flagRSP2:GetflagRSP2TooltipShowPvPTitleCheck()
	return flagRSP2.db.profile.flagRSP2TooltipShowPvPTitleCheck
end
function flagRSP2:SetflagRSP2TooltipShowPvPTitleCheck()
	flagRSP2.db.profile.flagRSP2TooltipShowPvPTitleCheck = not flagRSP2.db.profile.flagRSP2TooltipShowPvPTitleCheck
end
function flagRSP2:GetflagRSP2DescShowTitleCheck()
	return flagRSP2.db.profile.flagRSP2DescShowTitleCheck
end
function flagRSP2:SetflagRSP2DescShowTitleCheck()
	flagRSP2.db.profile.flagRSP2DescShowTitleCheck = not flagRSP2.db.profile.flagRSP2DescShowTitleCheck
end
function flagRSP2:GetflagRSP2DescShowStatusCheck()
	return flagRSP2.db.profile.flagRSP2DescShowStatusCheck
end
function flagRSP2:SetflagRSP2DescShowStatusCheck()
	flagRSP2.db.profile.flagRSP2DescShowStatusCheck = not flagRSP2.db.profile.flagRSP2DescShowStatusCheck
end

--Database Options
function flagRSP2:GetflagRSP2DescAutoDBCleanCheck()
	return flagRSP2.db.profile.flagRSP2DescAutoDBCleanCheck
end
function flagRSP2:SetflagRSP2DescAutoDBCleanCheck()
	flagRSP2.db.profile.flagRSP2DescAutoDBCleanCheck = not flagRSP2.db.profile.flagRSP2DescAutoDBCleanCheck
end

--LibDBIcon Options
function flagRSP2:GetflagRSP2MMIconCheck()
	return flagRSP2.db.profile.flagRSP2MMIconCheck
end
function flagRSP2:SetflagRSP2MMIconCheck()
	flagRSP2.db.profile.flagRSP2MMIconCheck = not flagRSP2.db.profile.flagRSP2MMIconCheck
	if (flagRSP2.db.profile.flagRSP2MMIconCheck == true) then
		FRSPICON:Show("flagRSP2")
	else
		FRSPICON:Hide("flagRSP2")
	end
end

local optionsvname = "flagRSP2 " .. frspversion

flagRSP2.options = {
	name = "flagRSP2 " .. GetAddOnMetadata("flagRSP2", "Version"),
	handler = flagRSP2,
	type = 'group',
	args = {
		frsp2options = {
			name = "flagRSP2",
			desc = '',
			order = 1,
			type = 'group',
			args = {
				General = {
					name = "flagRSP2 " .. GetAddOnMetadata("flagRSP2", "Version") .. " General Options",
					type = 'group',
					order = 1,
					guiInline = true,
					args = {
						flagRSP2OptionsSaveDescCheck = {
							type = 'toggle',
							name = FLAGRSP2_SAVE_DESCRIPTIONS,
							desc = FLAGRSP2_SAVE_DESCRIPTIONS_DESC,
							get = "GetflagRSP2OptionsSaveDescCheck",
							set = "SetflagRSP2OptionsSaveDescCheck",
							width = 'full',
							order = 2,
						},
						flagRSP2OptionsShowDescCheck = {
							type = 'toggle',
							name = FLAGRSP2_SHOW_TARGET_CHARACTER_DESCRIPTION,
							desc = FLAGRSP2_SHOW_DESCRIPTION_ONLY_WHEN_TARGETTING_PLAYER_DESC,
							get = "GetflagRSP2OptionsShowDescCheck",
							set = "SetflagRSP2OptionsShowDescCheck",
							width = 'full',
							order = 3,
						},
						flagRSP2OptionsTargetDescCheck = {
							type = 'toggle',
							name = FLAGRSP2_SHOW_DESCRIPTION_ONLY_WHEN_TARGETTING_PLAYER,
							desc = FLAGRSP2_SHOW_DESCRIPTION_ONLY_WHEN_TARGETTING_PLAYER_DESC,
							get = "GetflagRSP2OptionsTargetDescCheck",
							set = "SetflagRSP2OptionsTargetDescCheck",
							width = 'full',
							order = 4,
						},
						flagRSP2OptionsStickyDescCheck = {
							type = 'toggle',
							name = FLAGRSP2_STICKY_DESCRIPTION,
							desc = FLAGRSP2_STICKY_DESCRIPTION_DESC,
							get = "GetflagRSP2OptionsStickyDescCheck",
							set = "SetflagRSP2OptionsStickyDescCheck",
							width = 'full',
							order = 5,
						},
						flagRSP2OptionsHideCombatCheck = {
							type = 'toggle',
							name = FLAGRSP2_HIDE_DESCRIPTIONS_DURING_AND_ENTERING_COMBAT,
							desc = FLAGRSP2_HIDE_DESCRIPTIONS_DURING_AND_ENTERING_COMBAT_DESC,
							get = "GetflagRSP2OptionsHideCombatCheck",
							set = "SetflagRSP2OptionsHideCombatCheck",
							width = 'full',
							order = 6,
						},
						flagRSP2OptionsWordLimitCheck = {
							type = 'toggle',
							name = FLAGRSP2_CUT_OFF_TITLES,
							desc = FLAGRSP2_CUT_OFF_TITLES_DESC,
							get = "GetflagRSP2OptionsWordLimitCheck",
							set = "SetflagRSP2OptionsWordLimitCheck",
							width = 'full',
							order = 7,
						},
						flagRSP2OptionsAFKCheck = {
							type = 'toggle',
							name = FLAGRSP2_AFK,
							desc = FLAGRSP2_AFK_DESC,
							get = "GetflagRSP2OptionsAFKCheck",
							set = "SetflagRSP2OptionsAFKCheck",
							width = 'full',
							order = 8,
						},
					},
				},
				gametooltip = {
					name = 'Enhanced GameTooltip',
					type = 'group',
					order = 9,
					guiInline = true,
					args = {
						flagRSP2TooltipLightModeCheck = {
							type = 'toggle',
							name = FLAGRSP2_LIGHT_MODE_TOOLTIP,
							desc = FLAGRSP2_LIGHT_MODE_TOOLTIP_DESC,
							get = "GetflagRSP2TooltipLightModeCheck",
							set = "SetflagRSP2TooltipLightModeCheck",
							width = 'full',
							order = 9,
						},
						flagRSP2TooltipShowAddNameCheck = {
							type = 'toggle',
							name = FLAGRSP2_ENHANCED_ADDITIONAL_NAME,
							desc = "",
							get = "GetflagRSP2TooltipShowAddNameCheck",
							set = "SetflagRSP2TooltipShowAddNameCheck",
							width = 'full',
							order = 10,
						},
						flagRSP2TooltipShowTitleCheck = {
							type = 'toggle',
							name = FLAGRSP2_ENHANCED_TITLE,
							desc = "",
							get = "GetflagRSP2TooltipShowTitleCheck",
							set = "SetflagRSP2TooltipShowTitleCheck",
							width = 'full',
							order = 11,
						},
						flagRSP2TooltipShowGuildCheck = {
							type = 'toggle',
							name = FLAGRSP2_ENHANCED_GUILD,
							desc = "",
							get = "GetflagRSP2TooltipShowGuildCheck",
							set = "SetflagRSP2TooltipShowGuildCheck",
							width = 'full',
							order = 12,
						},
						flagRSP2TooltipShowStatusCheck = {
							type = 'toggle',
							name = FLAGRSP2_ENHANCED_STATUS,
							desc = "",
							get = "GetflagRSP2TooltipShowStatusCheck",
							set = "SetflagRSP2TooltipShowStatusCheck",
							width = 'full',
							order = 13,
						},
						flagRSP2TooltipShowPvPCheck = {
							type = 'toggle',
							name = FLAGRSP2_ENHANCED_PVP,
							desc = "",
							get = "GetflagRSP2TooltipShowPvPCheck",
							set = "SetflagRSP2TooltipShowPvPCheck",
							width = 'full',
							order = 14,
						},
						flagRSP2TooltipShowPvPTitleCheck = {
							type = 'toggle',
							name = FLAGRSP2_ENHANCED_PVP_TITLE,
							desc = "",
							get = "GetflagRSP2TooltipShowPvPTitleCheck",
							set = "SetflagRSP2TooltipShowPvPTitleCheck",
							width = 'full',
							order = 15,
						},
					},
				},

				descpopup = {
					name = FLAGRSP2_DESC_OPT,
					type = 'description',
					type = 'group',
					order = 16,
					guiInline = true,
					args = {
						flagRSP2DescShowTitleCheck = {
							type = 'toggle',
							name = FLAGRSP2_DESC_TITLE,
							desc = "",
							get = "GetflagRSP2DescShowTitleCheck",
							set = "SetflagRSP2DescShowTitleCheck",
							width = 'full',
							order = 17,
						},
						flagRSP2DescShowStatusCheck = {
							type = 'toggle',
							name = FLAGRSP2_DESC_STATUS,
							desc = "",
							get = "GetflagRSP2DescShowStatusCheck",
							set = "SetflagRSP2DescShowStatusCheck",
							width = 'full',
							order = 18,
						},
					},
				},
				minimap = {
					name = 'Minimap Icon Options',
					type = 'description',
					type = 'group',
					order = 20,
					guiInline = true,
					args = {
						flagRSP2MMIconHide = {
							type = 'toggle',
							name = FLAGRSP2_FUBAR_MINIMAP,
							desc = FLAGRSP2_FUBAR_MINIMAP_DESC,
							get = "GetflagRSP2MMIconCheck",
							set = "SetflagRSP2MMIconCheck",
							width = 'full',
							order = 21,
						},
					},
				},
				dbcleanup = {
					name = FLAGRSP2_DB_CLEAN_UP,
					type = 'description',
					type = 'group',
					order = 23,
					guiInline = true,
					args = {
						purgeselectivedb = {
							type = 'execute',
							name = FLAGRSP2_DB_PURGE_OLD,
							desc = FLAGRSP2_DB_PURGE_ALL_DESC,
							func = function() flagRSP2PurgeOldDB() end,
							order = 24,
						},
						purgealldb = {
							type = 'execute',
							name = FLAGRSP2_DB_PURGE_ALL,
							desc = FLAGRSP2_DB_PURGE_ALL_DESC,
							func = function() flagRSP2PurgeAllDB() end,
							order = 25,
						},
						flagRSP2DescAutoDBCleanCheck = {
							type = 'toggle',
							name = FLAGRSP2_DB_AUTO_PURGE,
							desc = FLAGRSP2_DB_AUTO_PURGE_DESC,
							get = "GetflagRSP2DescAutoDBCleanCheck",
							set = "SetflagRSP2DescAutoDBCleanCheck",
							width = 'full',
							order = 26,
						},
					},
				},
			},
		},
	},
}

function flagRSP2Options_Initialize()
	if (FlagList == nil) then
		FlagList = {};
	end
	if (FlagList[rName] == nil) then
		FlagList[rName] = {};
	end
	if (PlayerFlags == nil) then
		PlayerFlags = {};	
	end
	if (PlayerFlags[rName] == nil) then
		PlayerFlags[rName] = {};
	end
	if (PlayerFlags[rName][pName] == nil) then
		PlayerFlags[rName][pName] = {};
	end
	if (PlayerFlags[rName][pName]["CS"] == nil) then
		PlayerFlags[rName][pName]["CS"] = 2;
		flagRSP2OptionsCSSlider:SetValue(PlayerFlags[rName][pName]["CS"])
	else
		flagRSP2OptionsCSSlider:SetValue(PlayerFlags[rName][pName]["CS"])
	end
	if (PlayerFlags[rName][pName]["RP"] == nil) then
		PlayerFlags[rName][pName]["RP"] = 2;
		flagRSP2OptionsRPSlider:SetValue(PlayerFlags[rName][pName]["RP"])
	else
		flagRSP2OptionsRPSlider:SetValue(PlayerFlags[rName][pName]["RP"])
	end
	if (PlayerFlags[rName][pName]["FName"] == nil) then
		PlayerFlags[rName][pName]["FName"] = "";
	else
		flagRSP2PlayerFNameEdit:SetText(PlayerFlags[rName][pName]["FName"]);
	end
	if (PlayerFlags[rName][pName]["LName"] == nil) then
		PlayerFlags[rName][pName]["LName"] = "";
	else
		flagRSP2PlayerLNameEdit:SetText(PlayerFlags[rName][pName]["LName"]);
	end
	flagRSP2Player_NameDisplayText:SetText(PlayerFlags[rName][pName]["FName"] .. " " .. pName .. " " .. PlayerFlags[rName][pName]["LName"]);
	if (PlayerFlags[rName][pName]["Title"] == nil) then
		PlayerFlags[rName][pName]["Title"] = "";
	else
		flagRSP2PlayerTitleEdit:SetText(PlayerFlags[rName][pName]["Title"]);
	end
	if (PlayerFlags[rName][pName]["Desc"] == nil) then
		PlayerFlags[rName][pName]["Desc"] = {};
		PlayerFlags[rName][pName]["Desc"]["A"] = "";
	else
		flagRSP2PlayerDescEdit:SetText(PlayerFlags[rName][pName]["Desc"]["A"]);
	end

	if (PlayerFlags[rName][pName]["DV"] == nil) then
		PlayerFlags[rName][pName]["DV"] = -1;
	end

	FRSPLOADED = 1;
end

function flagRSP2AdvOptions_Update(option)
	statusupdate = 0;
	if (option == "timedupdate") then
		statusupdate = 1;
	end
	if (option == "textsendupdate" and textsendupdate == 1) then
		statusupdate = 1;
		textsendupdate = 0;
		if (descupdate == 1) then
			PlayerFlags[rName][pName]["DV"] = PlayerFlags[rName][pName]["DV"] + 1;
			descupdate = 0;
		end
	end
	if (option == flagRSP2OptionsCSSlider or option == flagRSP2OptionsRPSlider) then
		if (option == flagRSP2OptionsCSSlider) then
			if (PlayerFlags[rName][pName]["CS"] ~= flagRSP2OptionsCSSlider:GetValue()) then
				statusupdate = 1;
			end
			PlayerFlags[rName][pName]["CS"] = flagRSP2OptionsCSSlider:GetValue();
			if (PlayerFlags[rName][pName]["CS"] == 0) then
				getglobal(this:GetName().."Text"):SetText(FLAGRSP2_LUA_CSH);
			elseif (PlayerFlags[rName][pName]["CS"] == 1) then
				getglobal(this:GetName().."Text"):SetText(FLAGRSP2_LUA_OOC);
			elseif (PlayerFlags[rName][pName]["CS"] == 2) then
				getglobal(this:GetName().."Text"):SetText(FLAGRSP2_LUA_IC);
			elseif (PlayerFlags[rName][pName]["CS"] == 3) then
				getglobal(this:GetName().."Text"):SetText(FLAGRSP2_LUA_LFC);
			elseif (PlayerFlags[rName][pName]["CS"] == 4) then
				getglobal(this:GetName().."Text"):SetText(FLAGRSP2_LUA_ST);
			end
		end
		if (option == flagRSP2OptionsRPSlider) then
			if (PlayerFlags[rName][pName]["RP"] ~= flagRSP2OptionsRPSlider:GetValue()) then
				statusupdate = 1;
			end
			PlayerFlags[rName][pName]["RP"] = flagRSP2OptionsRPSlider:GetValue();
			if (PlayerFlags[rName][pName]["RP"] == 0) then
				getglobal(this:GetName().."Text"):SetText(FLAGRSP2_LUA_RSH);
			elseif (PlayerFlags[rName][pName]["RP"] == 1) then
				getglobal(this:GetName().."Text"):SetText(FLAGRSP2_LUA_RP);
			elseif (PlayerFlags[rName][pName]["RP"] == 2) then
				getglobal(this:GetName().."Text"):SetText(FLAGRSP2_LUA_CRP);
			elseif (PlayerFlags[rName][pName]["RP"] == 3) then
				getglobal(this:GetName().."Text"):SetText(FLAGRSP2_LUA_FRP);
			elseif (PlayerFlags[rName][pName]["RP"] == 4) then
				getglobal(this:GetName().."Text"):SetText(FLAGRSP2_LUA_BRP);
			elseif (PlayerFlags[rName][pName]["RP"] == 5) then
				getglobal(this:GetName().."Text"):SetText(FLAGRSP2_LUA_MRP);
			end
		end
	end

	if (option == flagRSP2PlayerFNameEdit) then
		PlayerFlags[rName][pName]["FName"] = flagRSP2PlayerFNameEdit:GetText();
		flagRSP2Player_NameDisplayText:SetText(PlayerFlags[rName][pName]["FName"] .. " " .. pName .. " " .. PlayerFlags[rName][pName]["LName"]);
		textsendupdate = 1;
	end
	if (option == flagRSP2PlayerLNameEdit) then
		PlayerFlags[rName][pName]["LName"] = flagRSP2PlayerLNameEdit:GetText();
		flagRSP2Player_NameDisplayText:SetText(PlayerFlags[rName][pName]["FName"] .. " " .. pName .. " " .. PlayerFlags[rName][pName]["LName"]);
		textsendupdate = 1;
	end
	if (option == flagRSP2PlayerTitleEdit) then
		PlayerFlags[rName][pName]["Title"] = flagRSP2PlayerTitleEdit:GetText();
		textsendupdate = 1;
	end
	if (option == flagRSP2PlayerDescEdit) then
		if (PlayerFlags[rName][pName]["Desc"]["A"] ~= flagRSP2PlayerDescEdit:GetText()) then
			PlayerFlags[rName][pName]["Desc"]["A"] = flagRSP2PlayerDescEdit:GetText();
			descupdate = 1;
			textsendupdate = 1;
		end
	end

	--Time to compose simple update messages.  Everything except for description will be sent in this step.  CSM stands for composed simple message.
	if (statusupdate == 1) then
		csm = "";
		csm = "<CS" .. PlayerFlags[rName][pName]["CS"] .. ">";
		csm = csm .. "<RP" .. PlayerFlags[rName][pName]["RP"] .. ">";
		csm = csm .. "<DV>" .. PlayerFlags[rName][pName]["DV"] .. "<AN1>" .. PlayerFlags[rName][pName]["FName"] .. "<AN3>" .. PlayerFlags[rName][pName]["LName"];
		flagRSP2:AddToBuffer(csm);
		csmt = "<T>" .. string.sub(PlayerFlags[rName][pName]["Title"], 1, 252);
		flagRSP2:AddToBuffer(csmt);
		--Clear DP Throttle Buffer.  May cause accidental spam over the communication channel, but this is better than allowing the buffer to slowly grow during the player's session.
		dpthrottle = {};
		statusupdate = 0;
	end
end